<form name="newEntryForm" novalidate autocomplete="off">
    <div class="modal-header">
        <button type="button" class="close" ng-click="cancel()"><span aria-hidden="true">&times;</span></button>
        <h3 class="modal-title">{{'NEW' | translate}} {{bp.selected.name | translate}}</h3>
    </div>
    <div class="modal-body" ng-if="!state.processing">

        <ui-select ng-model="bp.selected" class="form-group" on-select="on_select()">
            <ui-select-match>
                <span>{{ $select.selected.name | translate }}</span>
            </ui-select-match>
            <ui-select-choices repeat="blueprint in (bp.all | filter: $select.search) track by blueprint.id">
                <span>{{blueprint.name | translate}}</span>
            </ui-select-choices>
        </ui-select>

        <div class="form-group" ng-repeat="n in bp.selected.fields track by $index"
             ng-if="!n.tab && (!n.position || n.position === 'before')">
            <div ng-class="{'input-group': n.usernameInputGroupAddon && (! n.value || n.value.indexOf('@') === -1)}"
                 ng-if="n.field == 'input' && !n.dropmenuItems && n.usernameInputGroupAddon">
                <input type="text" class="form-control" id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                       ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly" aria-describedby="{{n.name}}-addon"
                       ng-change="bp.selected[n.onChange](bp.selected.fields, selected_server_domain)">
                <span class="input-group-addon" id="{{n.name}}-addon" ng-if="n.usernameInputGroupAddon && (n.value == null || n.value.indexOf('@') == -1)">@{{selected_server_domain}}</span>
            </div>

            <ui-select ng-model="n.value" ng-if="n.field == 'select'" ng-hide="n.hidden">
                <ui-select-match placeholder="{{ n.placeholder | translate }}">
                    <span>{{ n.value.name | translate }}</span>
                </ui-select-match>
                <!--<ui-select-choices repeat="value in bp.selected[n.get_values]()">-->
                <ui-select-choices repeat="value in n.values">
                    <span>{{value.name | translate}}</span>
                </ui-select-choices>
            </ui-select>

            <input ng-if="n.field == 'input' && !n.dropmenuItems && !n.usernameInputGroupAddon" type="{{n.type}}" name="{{n.name}}"
                   ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                   id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                   ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                   ng-change="bp.selected[n.onChange](bp.selected.fields)">
            <span ng-if="n.type == 'checkbox' && !n.dropmenuItems" ng-hide="n.hidden">{{n.title | translate }}</span>
            <button ng-if="n.field == 'button'" class="btn {{n.class}}" type="{{n.type}}" ng-hide="n.hidden" ng-click="bp.selected[n.onClick](node, bp.selected.fields, errors, form_control, selected_server_domain)">{{n.title | translate}}</button>

            <div class="input-group" ng-if="n.field == 'input' && n.type !== 'checkbox' && n.dropmenuItems">
                <input ng-if="n.field == 'input'" type="{{n.type}}" name="{{n.name}}" ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                       id="editEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                       ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                       ng-change="bp.selected[n.onChange](bp.selected.fields)">
                <div class="input-group-btn" uib-dropdown is-open="status.isopen">
                    <button id="single-button" type="button" class="btn btn-primary" uib-dropdown-toggle ng-disabled="disabled">
                        {{'ACTIONS' | translate}} <span class="caret"></span>
                    </button>
                    <ul class="dropdown-menu dropdown-menu-right" uib-dropdown-menu role="menu">
                        <li role="menuitem" ng-repeat="di in n.dropmenuItems track by $index" ng-if="!di.hide_offline || !offline">
                            <a href="" ng-click="di.onclick('editEntryForm-'+ n.name, di)"><i class="{{di.icon}}"></i>{{di.text | translate}}</a>
                        </li>
                    </ul>
                </div>
            </div>

            <uib-progressbar value="n.value | complexify" ng-if="n.type == 'password' && (n.value | complexify) > 0">
                <span complexify="n.value"></span>%
                <span complexify="n.value" type="verbal"></span>
            </uib-progressbar>

            <textarea ng-if="n.field == 'textarea'" name="{{n.name}}"
                      ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}" id="newEntryForm-{{n.name}}"
                      placeholder="{{n.placeholder | translate}}"  ng-required="n.required && !n.hidden"
                      ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"></textarea>
            <p class="help-block note" ng-hide="n.hidden">{{n.note | translate}}</p>

        </div>

        <!-- tabs -->
        <uib-tabset ng-if="bp.selected.tabs" class="tabset_expand">
            <uib-tab ng-repeat="tab in bp.selected.tabs" heading="{{tab.title | translate}}" active="tab.active" disable="tab.disabled">

                <div class="form-group" ng-repeat="n in bp.selected.fields track by $index"
                     ng-if="n.tab == tab.id">

                    <div ng-class="{'input-group': n.usernameInputGroupAddon && (! n.value || n.value.indexOf('@') == -1)}"
                         ng-if="n.field == 'input' && !n.dropmenuItems && n.usernameInputGroupAddon">
                        <input type="text" class="form-control" id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                               ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly" aria-describedby="{{n.name}}-addon"
                               ng-change="bp.selected[n.onChange](bp.selected.fields, selected_server_domain)">
                        <span class="input-group-addon" id="{{n.name}}-addon" ng-if="n.usernameInputGroupAddon && (n.value == null || n.value.indexOf('@') == -1)">@{{selected_server_domain}}</span>
                    </div>

                    <input ng-if="n.field == 'input' && !n.dropmenuItems && !n.usernameInputGroupAddon" type="{{n.type}}" name="{{n.name}}" ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                           id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                           ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                           ng-change="bp.selected[n.onChange](bp.selected.fields)">
                    <span ng-if="n.type == 'checkbox' && !n.dropmenuItems" ng-hide="n.hidden">{{n.title | translate}}</span>

                    <button ng-if="n.field == 'button'" class="btn {{n.class}}" type="{{n.type}}" ng-hide="n.hidden" ng-click="bp.selected[n.onClick](node, bp.selected.fields, errors, form_control, selected_server_domain)">{{n.title | translate}}</button>

                    <div class="input-group" ng-if="n.field == 'input' && n.type !== 'checkbox' && n.dropmenuItems">
                        <input ng-if="n.field == 'input'" type="{{n.type}}" name="{{n.name}}" ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                               id="editEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                               ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                               ng-change="bp.selected[n.onChange](bp.selected.fields)">
                        <div class="input-group-btn" uib-dropdown is-open="status.isopen">
                            <button id="single-button" type="button" class="btn btn-primary" uib-dropdown-toggle ng-disabled="disabled">
                                {{'ACTIONS' | translate}} <span class="caret"></span>
                            </button>
                            <ul class="dropdown-menu dropdown-menu-right" uib-dropdown-menu role="menu">
                                <li role="menuitem" ng-repeat="di in n.dropmenuItems track by $index" ng-if="!di.hide_offline || !offline">
                                    <a href="" ng-click="di.onclick('editEntryForm-'+ n.name, di)"><i class="{{di.icon}}"></i>{{di.text | translate}}</a>
                                </li>
                            </ul>
                        </div>
                    </div>

                    <uib-progressbar value="n.value | complexify" ng-if="n.type == 'password' && (n.value | complexify) > 0">
                        <span complexify="n.value"></span>%
                        <span complexify="n.value" type="verbal"></span>
                    </uib-progressbar>

                    <textarea ng-if="n.field == 'textarea'" name="{{n.name}}"
                              ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}" id="newEntryForm-{{n.name}}"
                              placeholder="{{n.placeholder | translate}}"  ng-required="n.required && !n.hidden"
                              ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"></textarea>
                    <p class="help-block note" ng-hide="n.hidden">{{n.note | translate}}</p>

                </div>
            </uib-tab>
        </uib-tabset>

        <!-- below tabs -->
        <div class="form-group" ng-repeat="n in bp.selected.fields track by $index"
             ng-if="!n.tab && n.position == 'after'">

            <div ng-class="{'input-group': n.usernameInputGroupAddon && (! n.value || n.value.indexOf('@') == -1)}"
                 ng-if="n.field == 'input' && !n.dropmenuItems && n.usernameInputGroupAddon">
                <input type="text" class="form-control" id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                       ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly" aria-describedby="{{n.name}}-addon"
                       ng-change="bp.selected[n.onChange](bp.selected.fields, selected_server_domain)">
                <span class="input-group-addon" id="{{n.name}}-addon" ng-if="n.usernameInputGroupAddon && (n.value == null || n.value.indexOf('@') == -1)">@{{selected_server_domain}}</span>
            </div>

            <input ng-if="n.field == 'input' && !n.dropmenuItems && !n.usernameInputGroupAddon" type="{{n.type}}" name="{{n.name}}" ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                   id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                   ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                   ng-change="bp.selected[n.onChange](bp.selected.fields)">
            <span ng-if="n.type == 'checkbox' && !n.dropmenuItems" ng-hide="n.hidden">{{n.title | translate}}</span>

            <button ng-if="n.field == 'button'" class="btn {{n.class}}" type="{{n.type}}" ng-hide="n.hidden" ng-click="bp.selected[n.onClick](node, bp.selected.fields, errors, form_control, selected_server_domain)">{{n.title | translate}}</button>

            <div class="input-group" ng-if="n.field == 'input' && n.type !== 'checkbox' && n.dropmenuItems">
                <input ng-if="n.field == 'input'" type="{{n.type}}" name="{{n.name}}" ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                       id="editEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                       ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                       ng-change="bp.selected[n.onChange](bp.selected.fields)">
                <div class="input-group-btn" dropdown is-open="status.isopen">
                    <button id="single-button" type="button" class="btn btn-primary" dropdown-toggle ng-disabled="disabled">
                        {{'ACTIONS' | translate}} <span class="caret"></span>
                    </button>
                    <ul class="dropdown-menu dropdown-menu-right" uib-dropdown-menu role="menu">
                        <li role="menuitem" ng-repeat="di in n.dropmenuItems track by $index" ng-if="!di.hide_offline || !offline">
                            <a href="#" ng-click="di.onclick('editEntryForm-'+ n.name, di)"><i class="{{di.icon}}"></i>{{di.text | translate}}</a>
                        </li>
                    </ul>
                </div>
            </div>

            <uib-progressbar value="n.value | complexify" ng-if="n.type == 'password' && (n.value | complexify) > 0">
                <span complexify="n.value"></span>%
                <span complexify="n.value" type="verbal"></span>
            </uib-progressbar>

            <textarea ng-if="n.field == 'textarea'" name="{{n.name}}"
                      ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}" id="newEntryForm-{{n.name}}"
                      placeholder="{{n.placeholder | translate}}"  ng-required="n.required && !n.hidden"
                      ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"></textarea>
            <p class="help-block note" ng-hide="n.hidden">{{n.note | translate}}</p>

        </div>

        <!-- Advanced -->
        <div class="text-right" ng-show="!hide_advanced">
            <a href="" ng-click="isCollapsed = !isCollapsed">{{'ADVANCED' | translate}}</a>
        </div>

        <div uib-collapse="isCollapsed">

            <div class="form-group" ng-repeat="n in bp.selected.fields track by $index"
                 ng-if="!n.tab && n.position == 'advanced'">

                <div ng-class="{'input-group': n.usernameInputGroupAddon && (! n.value || n.value.indexOf('@') == -1)}"
                     ng-if="n.field == 'input' && !n.dropmenuItems && n.usernameInputGroupAddon">
                    <input type="text" class="form-control" id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                           ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly" aria-describedby="{{n.name}}-addon"
                           ng-change="bp.selected[n.onChange](bp.selected.fields, selected_server_domain)">
                    <span class="input-group-addon" id="{{n.name}}-addon" ng-if="n.usernameInputGroupAddon && (n.value == null || n.value.indexOf('@') == -1)">@{{selected_server_domain}}</span>
                </div>

                <input ng-if="n.field == 'input' && !n.dropmenuItems && !n.usernameInputGroupAddon" type="{{n.type}}" name="{{n.name}}" ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                       id="newEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                       ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                       ng-change="bp.selected[n.onChange](bp.selected.fields)">
                <span ng-if="n.type == 'checkbox' && !n.dropmenuItems" ng-hide="n.hidden">{{n.title | translate}}</span>

                <button ng-if="n.field == 'button'" class="btn {{n.class}}" type="{{n.type}}" ng-hide="n.hidden" ng-click="bp.selected[n.onClick](node, bp.selected.fields, errors, form_control, selected_server_domain)">{{n.title | translate}}</button>

                <div class="input-group" ng-if="n.field == 'input' && n.type !== 'checkbox' && n.dropmenuItems">
                    <input ng-if="n.field == 'input'" type="{{n.type}}" name="{{n.name}}" ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}"
                           id="editEntryForm-{{n.name}}" placeholder="{{n.placeholder | translate}}" ng-required="n.required && !n.hidden"
                           ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"
                           ng-change="bp.selected[n.onChange](bp.selected.fields)">
                    <div class="input-group-btn" uib-dropdown is-open="status.isopen">
                        <button id="single-button" type="button" class="btn btn-primary" uib-dropdown-toggle ng-disabled="disabled">
                            {{'ACTIONS' | translate}} <span class="caret"></span>
                        </button>
                        <ul class="dropdown-menu dropdown-menu-right" uib-dropdown-menu role="menu">
                            <li role="menuitem" ng-repeat="di in n.dropmenuItems track by $index" ng-if="!di.hide_offline || !offline">
                                <a href="#" ng-click="di.onclick('editEntryForm-'+ n.name, di)"><i class="{{di.icon}}"></i>{{di.text | translate}}</a>
                            </li>
                        </ul>
                    </div>
                </div>

                <uib-progressbar value="n.value | complexify" ng-if="n.type == 'password' && (n.value | complexify) > 0">
                    <span complexify="n.value"></span>%
                    <span complexify="n.value" type="verbal"></span>
                </uib-progressbar>

                <textarea ng-if="n.field == 'textarea'" name="{{n.name}}"
                      ng-class="{'form-control': n.type !== 'checkbox', 'monospace': n.type === 'password'}" id="newEntryForm-{{n.name}}"
                      placeholder="{{n.placeholder | translate}}"  ng-required="n.required && !n.hidden"
                          ng-model="n.value" ng-hide="n.hidden" ng-readonly="n.readonly"></textarea>
                <p class="help-block note" ng-hide="n.hidden">{{n.note | translate}}</p>
            </div>
            <div class="form-group" ng-if="!bp.selected.hide_callback">
                <input type="text" name="callback_url" class="form-control"
                       id="editEntryForm-callback_url" placeholder="{{ 'CALLBACK_URL_PLACEHOLDER' | translate}}"
                       ng-model="data.callback_url">
            </div>
            <div class="form-group" ng-if="!bp.selected.hide_callback">
                <input type="text" name="callback_user" class="form-control"
                       id="editEntryForm-callback_user" placeholder="{{ 'CALLBACK_USER' | translate}}"
                       ng-model="data.callback_user">
            </div>
            <div class="form-group" ng-if="!bp.selected.hide_callback">
                <div class="input-group">
                    <input type="password" class="form-control" id="callback_pass" placeholder="{{ 'CALLBACK_PASS' | translate}}"  ng-model="data.callback_pass">
                    <span class="input-group-btn">
                        <button class="btn btn-default" type="button" ng-click="toggle_input_type('callback_pass')">
                            <i class="fa fa-eye-slash"></i>
                        </button>
                    </span>
                </div>
            </div>

        </div>

        <div ng-repeat="e in errors" class="help-block">
            <span translate="{{ e }}" ng-if="e !== 'INSUFFICIENT_FUNDS' || !credit_buy_address"></span>
            <span translate="{{ 'INSUFFICIENT_FUNDS_WITH_CREDIT_BUY_ADDRESS' }}" ng-if="e === 'INSUFFICIENT_FUNDS' && credit_buy_address"></span>
            <a ng-href="{{ credit_buy_address }}" ng-if="e === 'INSUFFICIENT_FUNDS' && credit_buy_address" rel="nofollow noopener" target="_blank">
                <span translate="{{ 'BUY' }}"></span>
            </a>
        </div>
        <div ng-repeat="e in msgs" class="help-block">
            <span translate="{{ e }}"></span>
        </div>

    </div>
    <div class="modal-body" ng-if="state.processing">

        <uib-progressbar max="state.open_requests" value="state.closed_request" ng-if="state.processing">
            <span style="color:white; white-space:nowrap;">{{ state.percentage_complete }} %</span>
        </uib-progressbar>
        <span translate="{{ state.next_step }}"></span>

    </div>
    <div class="modal-footer">
        <button class="btn btn-primary" ng-disabled="form_control.block_submit || processing" type="button" ng-click="submitted=true; save();">OK</button>
    </div>
</form>